# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `rime-api-key` header.

    The version of the OpenAPI document: 1.0
    Contact: dev@robustintelligence.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501
from pathlib import Path
from subprocess import CalledProcessError, run

from setuptools import find_packages, setup

CUR_DIR = Path(__file__).parent
git_root_path = (CUR_DIR / "../..").resolve()

with open(git_root_path / "version.txt", encoding="utf-8") as f:
    version_txt = f.read().strip()
try:
    semver = run(
        [git_root_path / "ci/bin/rime-semver"],
        check=True,
        encoding="utf-8",
        capture_output=True,
    ).stdout.strip()
except (CalledProcessError, AttributeError):
    semver = version_txt

# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools
NAME = "robustintelligence"
PYTHON_REQUIRES = ">=3.7"
REQUIRES = [
    "urllib3 >= 1.25.3, < 2.1.0",
    "python-dateutil",
    "pydantic >= 2",
    "typing-extensions >= 4.7.1",
]

setup(
    name=NAME,
    version=semver,
    description="Robust Intelligence REST API SDK",
    author="Robust Intelligence",
    author_email="dev@robustintelligence.com",
    url="",
    keywords=["Robust Intelligence REST API SDK", "Robust Intelligence SDK"],
    install_requires=REQUIRES,
    packages=find_packages(exclude=["test", "tests"]),
    include_package_data=True,
    license="OSI Approved :: Apache Software License",
    long_description_content_type="text/markdown",
    long_description="""\
    API methods for Robust Intelligence. Users must authenticate using the 'rime-api-key' or 'X-Firewall-Auth-Token' header.
    """,  # noqa: E501
    package_data={"ri.apiclient": ["py.typed"], "ri.fwclient": ["py.typed"]},
)
